package Generics;
import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.List;

public class SetGeneric<T>{
    private final ArrayList<T> places;
    private final int maxCount;
    public int getCount() {return places.size();}
    public SetGeneric(int count){
        maxCount = count;
        places = new ArrayList<>();
    }
    public boolean insert(T plane){
        if (places.size() == maxCount)
            return false;
        return insert(plane, 0);
    }
    public boolean insert(T plane, int position){
        if (!(position >= 0 && position <= places.size() && places.size() < maxCount))
            return false;
        places.add(position, plane);
        return true;
    }
    public boolean remove(int position){
        if(!(position >= 0 && position < places.size()))
            return false;
        places.remove(position);
        return true;
    }
    public T Get(int position){
        if(!(position >= 0 && position < places.size()))
            return null;
        return places.get(position);
    }
    public ArrayList<T> getPlanes(int maxPlanes){
        ArrayList<T> toRet = new ArrayList<>();
        for(int i = 0; i < places.size(); i++){
            toRet.add(places.get(i));
            if(i == maxPlanes)
                return toRet;
        }
        return toRet;
    }
}