package drawing_objects;

import entities.EntityAirBomber;

import java.awt.*;

public class ExtentionDrawingPlane {
    private static String getName(Color col){
        if(col.equals(Color.RED))
            return "RED";
        if(col.equals(Color.GREEN))
            return "GREEN";
        if(col.equals(Color.BLUE))
            return "BLUE";
        if(col.equals(Color.YELLOW))
            return "YELLOW";
        if(col.equals(Color.WHITE))
            return "WHITE";
        if(col.equals(Color.GRAY))
            return "GRAY";
        if(col.equals(Color.BLACK))
            return "BLACK";
        if(col.equals(Color.MAGENTA))
            return "MAGENTA";
        return null;
    }

    private static Color getColor(String col){
        if(col.equals("RED"))
            return Color.RED;
        if(col.equals("GREEN"))
            return Color.GREEN;
        if(col.equals("BLUE"))
            return Color.BLUE;
        if(col.equals("YELLOW"))
            return Color.YELLOW;
        if(col.equals("WHITE"))
            return Color.WHITE;
        if(col.equals("GRAY"))
            return Color.GRAY;
        if(col.equals("BLACK"))
            return Color.BLACK;
        if(col.equals("MAGENTA"))
            return Color.MAGENTA;
        return null;
    }
    public static DrawingPlane CreateDrawingPlane(String info, char separatorForObject,
                                                          int width, int height){
        String[] strs = info.split(Character.toString(separatorForObject));
        if(strs.length == 5){
            return new DrawingPlane(Integer.parseInt(strs[0]),
                    Integer.parseInt(strs[1]), getColor(strs[2]), width, height, Integer.parseInt(strs[3]), Integer.parseInt(strs[4]));
        }
        if(strs.length == 8){
            return new DrawingAirBomber(Integer.parseInt(strs[0]),
                    Integer.parseInt(strs[1]), getColor(strs[2]),
                    getColor(strs[5]), Boolean.parseBoolean(strs[6]),
                    Boolean.parseBoolean(strs[7]), width, height,
                    Integer.parseInt(strs[3]), Integer.parseInt(strs[4]));
        }
        return null;
    }
    public static String GetDataForSave(DrawingPlane drawingPlane, char separatorForObject){
        var plane = drawingPlane;
        var entity = plane.entityPlane;
        if(entity == null)
            return null;
        var str = String.format("%d%c%d%c%s%c%d%c%d", entity.getSpeed(), separatorForObject, (int)entity.getWeight(),
                separatorForObject, getName(entity.bodyColor), separatorForObject, plane.drawingEngines.getType(), separatorForObject, plane.drawingEngines.getNumber());
        if(!(entity instanceof EntityAirBomber)){
            return str;
        }
        var nstr = String.format("%s%c%s%c%b%c%b", str, separatorForObject,
                getName(((EntityAirBomber) entity).additionalColor), separatorForObject,
                ((EntityAirBomber) entity).getBombs(), separatorForObject,
                ((EntityAirBomber) entity).getFuel());
        return nstr;
    }
}
