package form;

import Generics.HardGeneric;
import drawing_objects.*;
import entities.EntityAirBomber;
import entities.EntityPlane;

import javax.swing.*;
import java.awt.*;
import java.util.Random;

public class FrameHard extends JFrame {
    HardGeneric<EntityPlane, IDrawEngines> generic;
    DrawingPlane drawing;
    private JComponent pictureBox;
    private final int pictureBoxWidth = 200;
    private final int pictureBoxHeight = 200;

    public FrameHard() {
        setLocationRelativeTo(null);
        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        pictureBox = new JComponent() {
            public void paintComponent(Graphics graphics) {
                super.paintComponent(graphics);
                Graphics2D graphics2D = (Graphics2D) graphics;
                if (drawing != null) drawing.drawTransport(graphics2D);
                super.repaint();
            }
        };
        pictureBox.setPreferredSize(new Dimension(pictureBoxWidth, pictureBoxHeight));
        JButton buttonMakeObject = new JButton("Создать новый объект");
        Random rand = new Random();
        int size = rand.nextInt(1, 10);
        generic = new HardGeneric<>(size, size, pictureBoxWidth, pictureBoxHeight);
        for (int i = 0; i < size; i++) {
            generic.InsertPlanes(makeRandomPlane());
            generic.InsertEngine(makeRandomEngine());
        }
        buttonMakeObject.addActionListener(e -> {
            DrawingPlane drawingPlane = generic.makeObject();
            drawingPlane.setPosition(pictureBoxWidth / 2 - drawingPlane.getWidth() / 2, pictureBoxHeight / 2 - drawingPlane.getHeight() / 2);
            drawing = drawingPlane;
            draw();
        });
        setLayout(new BorderLayout());
        add(pictureBox, BorderLayout.CENTER);
        add(buttonMakeObject, BorderLayout.SOUTH);
        pack();
        setVisible(true);
    }

    public EntityPlane makeRandomPlane() {
        Random rand = new Random();
        EntityPlane plane;
        switch (rand.nextInt(2)){
            case 1 -> plane = new EntityAirBomber(rand.nextInt(100, 300), rand.nextDouble(1000, 3000),
                    new Color(rand.nextInt(256), rand.nextInt(256), rand.nextInt(256)),
                    new Color(rand.nextInt(256), rand.nextInt(256), rand.nextInt(256)),
                    rand.nextBoolean(), rand.nextBoolean());
            default -> plane = new EntityPlane(rand.nextInt(100, 300), rand.nextDouble(1000, 3000),
                    new Color(rand.nextInt(256), rand.nextInt(256), rand.nextInt(256)));
        }
        return plane;
    }

    public IDrawEngines makeRandomEngine() {
        Random random = new Random();
        IDrawEngines engines;
        switch (random.nextInt(3)) {
            case 1 -> engines = new DrawingEnginesNotRounded();
            case 2 -> engines = new DrawingEnginesRoundedFront();
            default -> engines = new DrawingEnginesRoundedBack();
        }
        engines.setNumber((random.nextInt(3) + 1) * 2);
        return engines;
    }

    void draw() {
        pictureBox.repaint();
    }
}
